.set-application-repository: &set-application-repository
  - |
    if [[ -z "$CI_COMMIT_TAG" ]]; then
      export CI_APPLICATION_REPOSITORY=${CI_APPLICATION_REPOSITORY:-$CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG}
    else
      export CI_APPLICATION_REPOSITORY=${CI_APPLICATION_REPOSITORY:-$CI_REGISTRY_IMAGE/$CI_COMMIT_TAG}
    fi
  - |
    if [[ -z "$REPOSITORY_PATH" ]]; then
      export CI_APPLICATION_REPOSITORY="$REPOSITORY_PATH/$CI_PROJECT_ID-$CI_PROJECT_NAME"
    fi

.set-protected-namespace-tpl: &set-protected-namespace-tpl
  - |
    if [[ "$KUBERNETES_MULTIPLY" != "true" ]]; then
      export WERF_NAMESPACE_TPL="$CI_PROJECT_PATH_SLUG-$CI_ENVIRONMENT_SLUG"
    else
      export WERF_NAMESPACE_TPL="$CI_PROJECT_PATH_SLUG"
    fi

.set-review-namespace-tpl: &set-review-namespace-tpl
  - |
    if [[ -z "$CI_COMMIT_TAG" && $CI_COMMIT_BRANCH != "master" && $CI_COMMIT_BRANCH != "main" && $CI_COMMIT_BRANCH != "staging" ]]; then
      export WERF_NAMESPACE_TPL="$CI_PROJECT_PATH_SLUG-$CI_ENVIRONMENT_SLUG"
    fi

.set-namespace-prefix: &set-namespace-prefix
  - |
    if [[ ! -z $NAMESPACE_PREFIX ]]; then
      export WERF_NAMESPACE_TPL="$NAMESPACE_PREFIX-$WERF_NAMESPACE_TPL"
    fi

.git-ignore: &git-ignore
  - git config core.sshCommand 'ssh -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no'
  - grep -qxF '.tmp/'  ~/.gitexclude || echo '.tmp/'  >> ~/.gitexclude
  - grep -qxF '.helm/' ~/.gitexclude || echo '.helm/' >> ~/.gitexclude
  - git config --global core.excludesFile '~/.gitexclude'

.download-helm-chart: &download-helm-chart
  - rm -rf .tmp/cicd/
  - werf helm pull --username --password --repo $HELM_CHART_REPO --version $HELM_CHART_VERSION $HELM_CHART_NAME --untar -d ./.tmp/cicd/charts/
  - cp -R .tmp/cicd/charts/$HELM_CHART_NAME .helm

.docker-config: &docker-config
  - export DOCKER_CONFIG=./.tmp/docker
  - export WERF_REPO="$CI_APPLICATION_REPOSITORY"
  - mkdir -p $DOCKER_CONFIG
  - echo $WERFDOCKERCONFIGJSON | base64 -d >> $DOCKER_CONFIG/config.json

.werf-type: &werf-type
  - type trdl && . $(trdl use werf 1.2 alpha)
  - type werf && source $(werf ci-env gitlab --as-file)

.werf-values: &werf-values
  - |
    counter=0
    for f in $(ls -d ".cicd/upgrade-values/${TARGET_ENV}/"*); do
      if [[ $f == *"werf-secret"* ]]; then continue; fi
      counter=$((counter+1))
      export WERF_VALUES_$counter=./$f
    done
  - |
    counter=0
    for f in $(ls -d ".cicd/upgrade-values/${TARGET_ENV}/werf-secret.yaml"*); do
      counter=$((counter++))
      export WERF_SECRET_VALUES_$counter=./$f
    done

.werf-debug: &werf-debug
  - |
    if [[ "$WERF_DEBUG" == "true" ]]; then
      export WERF_LOG_VERBOSE="true"
      export WERF_EXPERIMENTAL_DEPLOY_ENGINE=1
      env
      ls -lshA
      cat ~/.gitexclude
      cat .gitignore
    fi

.export_project_members: &export_project_members
  - |
    data=$(curl --header "PRIVATE-TOKEN: $TAGS_API_TOKEN" "$CI_API_V4_URL/projects/$CI_PROJECT_ID/members/all" | jq -a -c --arg prefix "oidc:" '$prefix + (.[] | select(.state=="active") | select(.access_level > 30) | select(.username!="root") .username)')
    data=${data[@]}
    data=${data// /, }
    oidc_members="{"$data"}"
    export WERF_SET_OIDC_MEMBERS=oidc.members=$oidc_members

.werf-init:
  tags:
    - werf
  before_script:
    - *set-application-repository
    - *set-protected-namespace-tpl
    - *set-review-namespace-tpl
    - *set-namespace-prefix
    - *git-ignore
    - *download-helm-chart
    - *docker-config
    - *werf-type
    - *werf-values
    - *werf-debug

.werf-deploy:
  tags:
    - werf
  before_script:
    - *set-application-repository
    - *set-protected-namespace-tpl
    - *set-review-namespace-tpl
    - *set-namespace-prefix
    - *git-ignore
    - *download-helm-chart
    - *docker-config
    - *werf-type
    - *werf-values
    - *werf-debug
    - werf helm repo add bitnami https://charts.bitnami.com/bitnami
    - werf helm dependency update
